using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace GenericPrinting
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
        private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

        public class Grid : GridControl
        {
            private bool UseDoubleBuffer = false;
            private bool UseGDI = true;

            public Grid() 
                : base()
            {
//                GridNonVirtualDataCache cache = new GridNonVirtualDataCache(this.Model);
//                Model.VolatileData = cache;
            }      

            /// <summary>
            /// get the VolatileData from Model
            /// </summary>
//            internal GridNonVirtualDataCache GridDataCache
//            {
//                get
//                {
//                    return Model.VolatileData as GridNonVirtualDataCache;
//                }
//            }

        

            #region PAINT overrides

            protected override void OnPaintBackground(System.Windows.Forms.PaintEventArgs pevent)
            {
                if (UseDoubleBuffer)
                    base.OnPaintBackground (pevent);
            }

            protected override void OnDrawCellDisplayText(GridDrawCellDisplayTextEventArgs e)
            {
                if (!UseGDI) base.OnDrawCellDisplayText (e);

                if (!UseGDI || e.Cancel)
                    return;

                //THE FOLLOWING INSTRUNCTIONS CAUSE THE PROBLEM
                e.Cancel = GridGdiPaint.Instance.DrawText(e.Graphics, e.DisplayText, e.TextRectangle, e.Style);
            }

            protected override void OnFillRectangleHook(GridFillRectangleHookEventArgs e)
            {
                if (!UseGDI) base.OnFillRectangleHook (e);

                if (!UseGDI || e.Cancel)
                    return;

                //THE FOLLOWING INSTRUNCTIONS CAUSE THE PROBLEM
                e.Cancel = GridGdiPaint.Instance.FillRectangle(e.Graphics, e.Bounds, e.Brush);
            }
            #endregion
        }
        
        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.button1 = new System.Windows.Forms.Button();
            this.button2 = new System.Windows.Forms.Button();
            this.gridControl1 = new Grid();
            //this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(128, 40);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(184, 23);
            this.button1.TabIndex = 0;
            this.button1.Text = "PrintPreview";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // button2
            // 
            this.button2.Location = new System.Drawing.Point(128, 88);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(184, 23);
            this.button2.TabIndex = 1;
            this.button2.Text = "Print";
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // gridControl1
            // 
            this.gridControl1.ColWidthEntries.AddRange(new Syncfusion.Windows.Forms.Grid.GridColWidth[] {
                                                                                                            new Syncfusion.Windows.Forms.Grid.GridColWidth(0, 35)});
            this.gridControl1.Location = new System.Drawing.Point(8, 128);
            this.gridControl1.Name = "gridControl1";
            this.gridControl1.RowHeightEntries.AddRange(new Syncfusion.Windows.Forms.Grid.GridRowHeight[] {
                                                                                                              new Syncfusion.Windows.Forms.Grid.GridRowHeight(0, 21)});
            this.gridControl1.Size = new System.Drawing.Size(528, 232);
            this.gridControl1.SmartSizeBox = false;
            this.gridControl1.TabIndex = 2;
            this.gridControl1.Text = "gridControl1";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(544, 366);
            this.Controls.Add(this.gridControl1);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.button1);
            this.Name = "Form1";
            this.Text = "Form1";
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
            //Uses the default printer.                       
            GridPrintDocument pd = new GridPrintDocument(gridControl1, true); 
            PrintPreviewDialog dlg = new PrintPreviewDialog() ;
            dlg.Document = pd;
            dlg.ShowDialog();
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
            GridPrintDocument pd = new GridPrintDocument(gridControl1, true);
            PrintDialog dlg = new PrintDialog();
            dlg.Document = pd;
            dlg.AllowSelection = true;
            DialogResult result = dlg.ShowDialog();
            if (result == DialogResult.OK)
            {
                pd.PrinterSettings = dlg.PrinterSettings;
                pd.Print();
            }
        }

		private void document_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
		{
			using(Pen p = new Pen(Color.Red))
			{
				Rectangle rect = e.PageBounds;
				rect.Inflate(-10, -10);
				e.Graphics.DrawRectangle(p, rect);
				using(Pen p1 = new Pen(Color.Blue))
				{
					rect.Inflate(-10, -10);
					e.Graphics.DrawRectangle(p1, rect);
				}
			}

			e.HasMorePages = false;
		}
	}
}
